!! ##############################################################################################
!!
!! Copyright 2012-2024 CNRS, INPT
!! Copyright 2013-2015 UPS
!!
!! This file is part of qr_mumps.
!!
!! qr_mumps is free software: you can redistribute it and/or modify
!! it under the terms of the GNU Lesser General Public License as
!! published by the Free Software Foundation, either version 3 of
!! the License, or (at your option) any later version.
!!
!! qr_mumps is distributed in the hope that it will be useful,
!! but WITHOUT ANY WARRANTY; without even the implied warranty of
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!! GNU Lesser General Public License for more details.
!!
!! You can find a copy of the GNU Lesser General Public License
!! in the qr_mumps/doc directory.
!!
!! ##############################################################################################

subroutine cqrm_spfct_trsm_clean_front(front, front_slv, lhs, transp, info)
  use qrm_dscr_mod
  use cqrm_fdata_mod
  use cqrm_sdata_mod
  use cqrm_solve_mod, protect => cqrm_spfct_trsm_clean_front
  use qrm_string_mod
  implicit none

  type(cqrm_front_type) :: front
  type(cqrm_rhs_type)   :: front_slv
  complex(r32)          :: lhs(:,:)
  character(len=*)      :: transp
  integer               :: info
  
  logical               :: bottomup

  info = 0
  
  if(min(front%m,front%n).le.0) return

  ! write(*,*)'cleaning front ', front%num
  bottomup = (qrm_str_tolower(transp(1:1)) .eq. qrm_conj_transp) .or. &
             (qrm_str_tolower(transp(1:1)) .eq. qrm_transp)

  if(bottomup .and. (front%m.gt.front%n)) lhs(front%rows(front%n+1:front%m),:) = qrm_czero

  ! call cqrm_dsmat_destroy(front_slv%rhs, seq=front%small.ne.0)

  return
end subroutine cqrm_spfct_trsm_clean_front
